/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <POURRIER Thibaud> wrote this file. As long as you retain this
 * notice you can do whatever you want with this stuff. If we meet some day,
 * and you think this stuff is worth it, you can buy me a beer in return.
 * Poul-Henning Kamp.
 * ----------------------------------------------------------------------------
 */

/******************************************************************************
		"main.h"
		This file is the header of the project BOBY.
*******************************************************************************/


#ifndef mainh
#define mainh

// Libraries
#include "avr/io.h"
#include "avr/eeprom.h"
//#define F_CPU	8000000UL	// 8MHz
#include "util/delay.h"
#include "avr/interrupt.h"

// GCC Macros
#define dms(m)	_delay_ms(m)
#define dus(u)	_delay_us(u)
typedef unsigned char	uchar;
typedef unsigned int	uint;


//------------------ Prototypes ------------------
int  main();
void Init();
void Calibration();
void Enter_target();
void Motor_on();
void Motor_off();
void Count();
void Uncount();
uchar Compare();

//------------------ Macros ----------------------
// LED
#define LED_ON			(PORTC |= _BV(PC4))
#define LED_OFF			(PORTC &= ~_BV(PC4))
// Buttons
#define PLUS			(PINB & _BV(PB6))
#define MINUS			(PIND & _BV(PD1))
#define RIGHT			(PIND & _BV(PD0))
#define LEFT			(PINB & _BV(PB7))
#define OK				(PIND & _BV(PD4))
// IR switches
#define IRSW1	(PIND & _BV(PD3))

//------------------ Constants -------------------
#define DIGIT		5		// Number of digits (2 to 8)
#define TARGET_ADD	0x40	// Screen add of the target number

//------------------ Vars ------------------------
volatile uchar Target[DIGIT];	// Target number of spins, set by user
volatile uchar Current[DIGIT];	// Current number of spins, count by hardware
volatile uchar ADCH_min;		// Minimum of ADCH
volatile uchar ADCH_max;		// Maximum of ADCH

//------------------ Flags -----------------------
//volatile unsigned char FLG_Global;
// Bit		|	7	|	6	|	5	|	4	||	3	|	2	|	1	|	0	|
// Name		|  		|		|  		| 		|| 		| 		| 		| 		|
// Default	|	1	|	0	|	0	|	X	||	X	|	X	|	X	|	X	|
/*#define _FLG		(REG_Global_Flg & _BV(7))
#define _FLG_ON	(REG_Global_Flg |= _BV(7))
#define _FLG_OFF	(REG_Global_Flg &= ~_BV(7))*/



/************************************************************
							DEBUG
************************************************************/
//#define DEBUG		// Uncomment this line for debuging mode
#ifdef DEBUG
void Hello_led();
#endif
/************************************************************/




// Headers
#include "screen4b.h"

#endif	//#define mainh
