/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <POURRIER Thibaud> wrote this file. As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.
 * Poul-Henning Kamp.
 * ----------------------------------------------------------------------------
 */

/******************************************************************************
		"screen4b.h"
		This file is the header of "screen4b.c".
		/!\ WARNING: This file is modified for the project BOBY /!\
*******************************************************************************/


#ifndef screen4bh
#define screen4bh

//#define SCR_2x8	// Comment this line if your screen is a 2x16 caracters screen


// Libraries
#include <string.h>
#include <stdlib.h>

//------------------ Macros ----------------------
#define EN_ON		PORTB |= _BV(PB1)	// Register Select
#define EN_OFF		PORTB &= ~_BV(PB1)
#define RS_ON		PORTB |= _BV(PB2)	// Enable
#define RS_OFF		PORTB &= ~_BV(PB2)
#define DATA		PORTC				// DB0..3
#define CLEAR_DATA	DATA &= 0xF0		// Delete DATA

#define CURSOR_ON	Write_cmd(0b00001110)
#define CURSOR_OFF	Write_cmd(0b00001100)

//------------------ Prototypes ------------------
void Write_cmd(unsigned char byte);
void Write_char(unsigned char data, unsigned char add);
#ifdef SCR_2x8
	void Write_str(char str[16], unsigned char add);
#else
	void Write_str(char str[32], unsigned char add);
#endif
void Write_nbr(int nbr, unsigned char add, uchar mode);
void Init_screen(void);
void Clear_screen(void);
void Return_home(void);

#endif //#define screen4bh

